Unit ML0810_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure ML0810(var B :Array of Real; var A :Array of Real;
                var NS :Array of Integer; var T :Array of Real;
                var NT :Array of Integer; N :Integer; M1 :Integer;
                DA :Integer; var ALFA :Array of Real; KV :Integer;
                NA :Integer; L :Integer; var X :Array of Real;
                var Z :Array of Real; var NX :Array of Integer;
                var NALFA :Array of Integer);

implementation

procedure ML0810(var B :Array of Real; var A :Array of Real;
                var NS :Array of Integer; var T :Array of Real;
                var NT :Array of Integer; N :Integer; M1 :Integer;
                DA :Integer; var ALFA :Array of Real; KV :Integer;
                NA :Integer; L :Integer; var X :Array of Real;
                var Z :Array of Real; var NX :Array of Integer;
                var NALFA :Array of Integer);
var
I,I1,J,K1,K2,K3,KT,M,M2 :Integer;
EPS1 :Real;
const
O1024 :Integer = 1024;
O16000 :Integer = 16000;
label
_10,_20,_30,_40,_50,_60,_70,_80;
begin
EPS1 := 0.1E-8;
M := M1-1;
K1 := NX[L-1];
for I:=1 to KV do
 begin
  K2 := NALFA[I-1];
  K3 := K2;
  if ( K2 > O16000 ) 
   then K3 := K2-O16000;
  if ( K3 = K1 ) and ( K2 = K3 ) 
   then goto _50;
  if ( K3 = K1 ) 
   then goto _20;
_10:
 end;
goto _50;
_20:
M2 := 0;
for J:=1 to K1 do
 begin
  KT := NT[J-1];
  if ( KT > O1024 ) 
   then KT := KT-O1024;
  M2 := M2+KT;
_30:
 end;
I1 := M2-KT+1;
for J:=I1 to M2 do
 begin
  K3 := NS[J-1];
  B[(K3-1)+(M1-1)*M1] := B[(K3-1)+(M1-1)*M1]-A[J-1]*ALFA[I-1];
_40:
 end;
_50:
if ( Abs(Z[M1-1]-1.0) < EPS1 ) 
 then goto _60;
goto _80;
_60:
for I:=1 to M do
 begin
  B[(I-1)+(M1-1)*M1] := B[(I-1)+(M1-1)*M1]+Z[I-1]*ALFA[NA-1];
_70:
 end;
_80:
end;

end.
