Unit ML0811_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure ML0811(var B :Array of Real; var ALFA1 :Real; var RO :Real;
                EPS :Real; M1 :Integer; var P :Integer);

implementation

procedure ML0811(var B :Array of Real; var ALFA1 :Real; var RO :Real;
                EPS :Real; M1 :Integer; var P :Integer);
var
E,I,I1,I2,I3,I5,J,M :Integer;
A,DEL :Real;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130;
begin
M := M1 - 1;
I5 := M - 1;
for I:=1 to I5 do
 begin
  ALFA1 := 0;
  for J:=I to M do
   begin
    ALFA1 := ALFA1 + IntPower(B[(J-1)+(I-1)*M1],2);
_10:
   end;
  ALFA1 := Sqrt(ALFA1);
  RO := 2*ALFA1*(ALFA1 + Abs(B[(I-1)+(I-1)*M1]));
  RO := Sqrt(RO);
  if ( Abs(B[(I-1)+(I-1)*M1]) <  EPS ) 
   then goto _40;
  if ( B[(I-1)+(I-1)*M1] <  0.0 ) 
   then goto _20;
  A := 1.0;
  goto _30;
_20:
  A := -1.0;
_30:
  ALFA1 := -ALFA1*A;
  goto _50;
_40:
  ALFA1 := -ALFA1;
_50:
  B[(M1-1)+(I-1)*M1] := B[(I-1)+(I-1)*M1] - ALFA1;
  if ( Abs(RO) >=  EPS ) 
   then goto _60;
  P := 4;
  goto _130;
_60:
  DEL := B[(M1-1)+(I-1)*M1]*B[(I-1)+(I-1)*M1];
  I1 := I + 1;
  for J:=I1 to M do
   begin
    DEL := DEL + IntPower(B[(J-1)+(I-1)*M1],2);
_70:
   end;
  DEL := DEL/RO;
  I1 := I + 1;
  for J:=I1 to M1 do
   begin
    B[(J-1)+(I-1)*M1] := B[(J-1)+(I-1)*M1]/RO;
_80:
   end;
  B[(I-1)+(I-1)*M1] := B[(I-1)+(I-1)*M1] - 2*DEL*B[(M1-1)+(I-1)*M1];
  I1 := I + 1;
  I2 := M + 1;
  for J:=I1 to I2 do
   begin
    DEL := B[(M1-1)+(I-1)*M1]*B[(I-1)+(J-1)*M1];
    I3 := I + 1;
    for E:=I3 to M do
     begin
      DEL := DEL + B[(E-1)+(J-1)*M1]*B[(E-1)+(I-1)*M1];
_90:
     end;
    B[(I-1)+(J-1)*M1] := B[(I-1)+(J-1)*M1] - 2*DEL*B[(M1-1)+(I-1)*M1];
    I3 := I + 1;
    for E:=I3 to M do
     begin
      B[(E-1)+(J-1)*M1] := B[(E-1)+(J-1)*M1] - 2*DEL*B[(E-1)+(I-1)*M1];
_100:
     end;
_110:
   end;
_120:
 end;
_130:
end;

end.
