Unit ML0814_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, ML0815_p;

procedure ML0814(var MIN :Real; var XK :Array of Real;
                M1 :Integer; var A :Array of Real;
                var NS :Array of Integer; DA :Integer;
                N :Integer; var SUM :Array of Real;
                var T :Array of Real; var NT :Array of Integer;
                var K :Integer; var ALFA :Array of Real; KV :Integer;
                var NALFA :Array of Integer);

implementation

procedure ML0814(var MIN :Real; var XK :Array of Real;
                M1 :Integer; var A :Array of Real;
                var NS :Array of Integer; DA :Integer;
                N :Integer; var SUM :Array of Real;
                var T :Array of Real; var NT :Array of Integer;
                var K :Integer; var ALFA :Array of Real; KV :Integer;
                var NALFA :Array of Integer);
var
J,K1,K2,K3,KT,NJ :Integer;
DEL :Real;
const
O1024 :Integer = 1024;
O16000 :Integer = 16000;
label
_10,_20,_30,_40,_50;
begin
K3 := 0;
K1 := 1;
NJ := 1;
MIN := 0;
for J:=1 to N do
 begin
  KT := NT[J-1];
  if ( KT > O1024 ) 
   then goto _40;
  if ( K1 >  KV ) 
   then goto _20;
_10:
  K2 := NALFA[K1-1];
  K3 := K2;
  if ( K2 > O16000 ) 
   then K3 := K2 - O16000;
  if ( J <=  K3 ) 
   then goto _20;
  K1 := K1+1;
  goto _10;
_20:
  ML0815(XK,M1,A,NS,DA,NJ,J,KT,T,N,DEL);
  if ( J <>  K3 ) 
   then goto _30;
  if ( K2 > O16000 ) 
   then DEL := -DEL;
_30:
  if ( DEL >=  MIN ) 
   then goto _50;
  MIN := DEL;
  K := J;
  goto _50;
_40:
  NJ := NJ + KT -O1024;
_50:
 end;
end;

end.
