Unit ML0816_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure ML0816(var T :Array of Real; var NT :Array of Integer;
                var SUM :Array of Real; var ALFA :Array of Real;
                var X :Array of Real; var DEL :Real; M1 :Integer;
                N :Integer; KV :Integer; var NX :Array of Integer;
                var NALFA :Array of Integer);

implementation

procedure ML0816(var T :Array of Real; var NT :Array of Integer;
                var SUM :Array of Real; var ALFA :Array of Real;
                var X :Array of Real; var DEL :Real; M1 :Integer;
                N :Integer; KV :Integer; var NX :Array of Integer;
                var NALFA :Array of Integer);
var
I,J,K1,K2,KT,M :Integer;
const
O1024 :Integer = 1024;
O16000 :Integer = 16000;
label
_10,_20,_30,_40,_50,_60;
begin
DEL := 0;
K2 := 0;
M := M1 - 1;
for J:=1 to N do
 begin
  KT := NT[J-1];
  if ( KT > O1024 ) 
   then goto _20;
  for I:=1 to KV do
   begin
    K1 := NALFA[I-1];
    K2 := K1;
    if ( K1 > O16000 ) 
     then K2 := K1 -O16000;
    if ( J <=  K2 ) 
     then goto _50;
_10:
   end;
  goto _60;
_20:
  KT := KT -O1024;
  for I:=1 to M do
   begin
    K1 := NX[I-1];
    if ( K1 =  J ) 
     then goto _40;
_30:
   end;
_40:
  DEL := DEL + SUM[K1-1]*X[I-1];
  goto _60;
_50:
  if ( J <>  K2 ) 
   then goto _60;
  if ( K2 <>  K1 ) 
   then DEL := DEL + ALFA[I-1]*SUM[K2-1];
_60:
 end;
end;

end.
