Unit ML08R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, ML0801_p, ML0802_p, ML0804_p, ML0805_p, ML0806_p, ML0807_p,
ML0808_p, ML0809_p, ML0810_p, ML0811_p, ML0812_p, ML0813_p, ML0814_p,
ML0816_p, ML0817_p, ML0818_p, ML0819_p, ML0821_p, ML0822_p, MLU33_p,
ML0823_p;

procedure ML08R(var A :Array of Real; var NS :Array of Integer;
                DA :Integer; var B :Array of Real;
                M1 :Integer; var T :Array of Real;
                var NT :Array of Integer; N :Integer;
                var SUM :Array of Real; var X :Array of Real;
                var P :Integer; EPS :Real; var XK :Array of Real;
                var Z :Array of Real; var ALFA :Array of Real;
                var KV :Integer; var NALFA :Array of Integer;
                var NX :Array of Integer);

implementation

procedure ML08R(var A :Array of Real; var NS :Array of Integer;
                DA :Integer; var B :Array of Real;
                M1 :Integer; var T :Array of Real;
                var NT :Array of Integer; N :Integer;
                var SUM :Array of Real; var X :Array of Real;
                var P :Integer; EPS :Real; var XK :Array of Real;
                var Z :Array of Real; var ALFA :Array of Real;
                var KV :Integer; var NALFA :Array of Integer;
                var NX :Array of Integer);
var
E,I,I1,K,K2,K5,KT,L,M,N1,NA,NE,NI,NJ1 :Integer;
ALFA1,DEL,EPS1,MIN,RO,SX,TETA :Real;
const
O1024 :Integer = 1024;
O16000 :Integer = 16000;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190,_200,_210,_220;
begin
if ( P <>  1 ) 
 then goto _20;
for I:=1 to N do
 begin
  T[I-1] := -T[I-1];
_10:
 end;
_20:
M := M1 - 1;
SX := 0.0;
for I:=1 to M do
 begin
  SX := SX + X[I-1];
_30:
 end;
EPS1 := EPS*SX;
{   OPMPOBAHE ACHO MATP }
{   HA EPBO TEPA. }
ML0821(B,X,M1);
for I:=1 to M do
 begin
  K := N + I;
  NX[I-1] := K;
_40:
 end;
NI := 0;
NE := 1;
{   PEEHE CCTEM YB=SUM }
{   OCK BBOMOO CTOA HA EPBOM TAE }
_50:
ML0801(XK,SUM,B,X,M1,N,NX);
ML0802(MIN,XK,M1,A,NS,DA,N,SUM,T,NT,K,NJ1,N1,ALFA,KV,NALFA);
goto _80;
{   PEEHE CCTEM YB=T HA BTOPOM TAE }
_60:
ML0813(XK,T,B,X,M1,N,NX);
{   OCK BBOMOO CTOA HA BTOPOM TAE }
ML0814(MIN,XK,M1,A,NS,DA,N,SUM,T,NT,K,ALFA,KV,NALFA);
goto _80;
{   PEEHE CCTEM YB=SUM HA TPETEM TAE }
_70:
ML0817(XK,SUM,B,X,M1,N,NX);
{   PEEHE CCTEM YB=T HA TPETEM TAE }
ML0818(Z,T,B,X,M1,N,NX);
{   OCK BBOMOO CTOA HA TPETEM TAE }
ML0819(MIN,M1,A,NS,DA,N,SUM,T,NT,K,ALFA,KV,EPS,XK,Z,NALFA);
_80:
if ( MIN <  -EPS ) 
 then goto _110;
case NE of
 1: goto _90;
 2: goto _190;
 3: goto _190;
end;
_90:
NE := 2;
for I:=1 to M do
 begin
  I1 := NX[I-1];
  if ( I1 >  N ) 
   then NE := 3;
_100:
 end;
{   BCEHE HAEH HEHO OPM }
ML0816(T,NT,SUM,ALFA,X,DEL,M1,N,KV,NX,NALFA);
B[(M1-1)+(M1-1)*M1] := DEL - B[(M1-1)+(M1-1)*M1];
if ( NE =  3 ) and (  Abs(B[(M1-1)+(M1-1)*M1]) >  EPS1 ) 
 then goto _200;
case NE of
 1: goto _50;
 2: goto _60;
 3: goto _70;
end;
_110:
if ( NE =  1 ) 
 then goto _130;
K2 := 0;
for I:=1 to K do
 begin
  KT := NT[I-1];
  if ( KT >  O1024 ) 
   then KT := KT - O1024;
  K2 := K2 + KT;
_120:
 end;
NJ1 := K2 - KT + 1;
N1 := K2;
{   PEEHE CCTEM B*XK=AK }
_130:
ML0805(Z,A,NS,M1,DA,B,NJ1,N1);
ML0806(Z,XK,B,M1);
NA := 0;
{   OCK CTOA, BBOMOO  ACA }
ML0822(X,M1,XK,K,L,TETA,EPS,ALFA,KV,NA,NALFA,NX);
{   BOP K-O CTOA  MATP YCOB }
ML0804(Z,A,NS,M1,DA,NJ1,N1);
if ( TETA =  10.E+10 ) 
 then goto _210;
Z[M1-1] := 0.0;
if ( NA =  0 ) 
 then goto _140;
K5 := NALFA[NA-1];
if ( K5 > O16000 ) 
 then Z[M1-1] := 1.0;
{   KOPPEKTPOBKA HOMEPOB EPEMEHHX, }
{   BEX HA BEPXH PAHY }
_140:
MLU33(TETA,L,K,XK,M1,ALFA,KV,NA,NALFA,NX);
if ( L <>  0 ) 
 then goto _150;
E := -1;
if ( TETA >  EPS ) 
 then E := 1;
{   PEOPAOBAHE BEKTOPA PABX ACTE }
{   B CYAE,KOA  TETA=  AA }
ML0807(Z,ALFA,B,M1,KV,NA,E);
{   EPECET BEKTOPA-PEEH, EC TETA=AA }
ML0808(X,NX,XK,ALFA,M1,K,L,TETA,KV,NA);
goto _180;
{   EPECET BEKTOPA PABX ACTE }
_150:
ML0810(B,A,NS,T,NT,N,M1,DA,ALFA,KV,NA,L,X,Z,NX,NALFA);
{   KOPPEKTPOBKA HOMEPOB ACHX KOMOHEHT }
ML0823(NX,M1,K,L,NT,N);
{   OPMPOBAHE ACHO MATP }
ML0809(T,NT,A,NS,B,X,M1,N,DA,NX);
for I:=1 to M do
 begin
  Z[I-1] := B[(I-1)+(M1-1)*M1];
_160:
 end;
{   PEOPAOBAHE ACHO MATP C }
{   OMO MATP OTPAEH }
ML0811(B,ALFA1,RO,EPS,M1,P);
if ( P =  4 ) 
 then goto _220;
{   EPECET PEEH }
ML0812(X,B,M1);
for I:=1 to M do
 begin
  B[(I-1)+(M1-1)*M1] := Z[I-1];
_170:
 end;
_180:
NI := NI + 1;
case NE of
 1: goto _50;
 2: goto _60;
 3: goto _70;
end;
{   BCEHE OTMAHOO HAEH }
{   HEHO OPM }
_190:
ML0816(T,NT,T,ALFA,X,DEL,M1,N,KV,NX,NALFA);
X[M1-1] := DEL;
if ( P =  1 ) 
 then X[M1-1] := -X[M1-1];
P := 1;
goto _220;
_200:
P := 2;
goto _220;
_210:
P := 3;
_220:
end;

end.
