Unit ML0808_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure ML0808(var X :Array of Real; var NX :Array of Integer;
                var XK :Array of Real; var ALFA :Array of Real;
                M1 :Integer; K :Integer; L :Integer; TETA :Real;
                KV :Integer; NA :Integer);

implementation

procedure ML0808(var X :Array of Real; var NX :Array of Integer;
                var XK :Array of Real; var ALFA :Array of Real;
                M1 :Integer; K :Integer; L :Integer; TETA :Real;
                KV :Integer; NA :Integer);
var
I,J,M :Integer;
label
_10,_20,_30;
begin
M := M1 - 1;
for I:=1 to M do
 begin
  J := NX[I-1];
  if ( I <>  L ) 
   then goto _20;
  if ( TETA <  0.0 ) 
   then goto _10;
  X[L-1] := TETA;
  goto _30;
_10:
  X[L-1] := ALFA[NA-1] + TETA;
  goto _30;
_20:
  X[I-1] := X[I-1] - TETA*XK[I-1];
  if ( X[I-1] <  0.0 ) 
   then X[I-1] := 0.0;
_30:
 end;
end;

end.
